/*
 *  Copyright (C) 2008, Pedro Carlos da Silva Lara
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.   
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#ifndef _HEADER_DHKEY_H_
#define _HEADER_DHKEY_H_

#include <gmpxx.h>
#include "key.h"
#include "point.h"
using ec::Point;
using ec::crypt::PublicKey;
using ec::crypt::PrivateKey;

namespace ec {
namespace crypt {
/**
 * Public Key to Diffie-Hellman Protocol
 * (class DiffieHellman)
 */
 
class DH_PublicKey : public PublicKey< Point > {
public:
	/**
	 */	
	DH_PublicKey( const Point& pub ) : PublicKey< Point >( pub ) {}
};

/**
 * Public Key to Diffie-Hellman Protocol
 * (class DiffieHellman)
 */
 
class DH_PrivateKey : public PrivateKey< mpz_class > {
public:
	/**
	 * 
	 */
	DH_PrivateKey( const mpz_class& priv ) : PrivateKey< mpz_class >( priv ) {}
};

} // namespace ec
} // namespace crypt
#endif /* _HEADER_DHKEY_H_ */
